#pragma once

#include "BitStream.h"

#include <vector>

class BufferBitStream : public BitStream
{
public:
    bool isFinished() const override;

    std::vector<unsigned char> peekNextNBytes(unsigned n) const override;

    std::optional<unsigned char> readNextByte() override;

    void setBuffer(const std::vector<unsigned char>& data);

    void writeByte(unsigned char data) override;

    void writeBytes(const std::vector<unsigned char> data) override
    {
        std::copy(data.begin(), data.end(), std::back_inserter(mBuffer));
    }

    const std::vector<unsigned char>& getBuffer() const
    {
        return mBuffer;
    }

    void resetOffsets()
    {
        mByteOffset = 0;
        mBitOffset = 0;
    }

private:
    std::vector<unsigned char> mBuffer;
};
